<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托单位:">
                <Input v-model="formObj.client" @on-enter="_formSearch" name="client" placeholder="请输入委托单位" clearable/>
              </Form-item>
              <Form-item class="search-item" label="委托单号:">
                <Input v-model="formObj.entrustCode" @on-enter="_formSearch" name="entrustCode" placeholder="请输入委托单号" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                     class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange" >
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.status">
                     {{scope.row[item.key].display}}
                  </span>
                  <span v-else-if="item.key==='edate'">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}
                  </span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <FileManage ref="FileManage"></FileManage>
    <MeterSubcontractorEdit ref="editSubcontractorModal" @on-result-change="_formSearch"></MeterSubcontractorEdit>
    <operationModal ref="operationModal" @on-result-change="_page"></operationModal>

    <MeterSampleManage ref="meterSampleManageModal"  @on-result-change="_page"></MeterSampleManage>
  </div>
</template>
<script>
import { meterEntrust } from '../../../api'
import MeterSampleManage from '../MeterSampleManage'
import http from '../../../api/http'
import MeterSubcontractorEdit from './MeterGoOutTestEdit'
import operationModal from './MeterGoOutOperation'
export default {
  components: { MeterSubcontractorEdit, operationModal, MeterSampleManage },
  data() {
    return {
      currentComponent: '',
      formId: 'meterSubcontractorFormId',
      searchOpen: false,
      btn: [
        {
          type: 'success',
          id: 'meter-go-out-entrust-add',
          name: '添加'
        },
        {
          type: 'success',
          id: 'meter-go-out-entrust-submit-review',
          name: '提交评审'
        },
        {
          type: 'success',
          id: 'meter-go-out-entrust-submit',
          name: '提交'
        }
      ],
      iconMsg: [
        {
          type: 'md-create',
          id: 'meter-go-out-entrust-edit-o',
          name: '编辑'
        },
        {
          type: 'ios-beaker',
          id: 'meter-go-out-entrust-sample-manage-o',
          name: '管理样品'
        },
        {
          type: 'md-cloud',
          id: 'meter-go-out-entrust-accessory-o',
          name: '附件'
        },
        {
          type: 'md-document',
          id: 'meter-go-out-entrust-export-entrust-o',
          name: '导出委托单'
        },
        {
          type: 'md-remove-circle',
          id: 'meter-go-out-entrust-remove-o',
          name: '删除'
        },
        {
          type: 'ios-clock',
          id: 'meter-go-out-entrust-record-o',
          name: '操作日志'
        }
      ],
      formObj: {
        client: undefined,
        entrustCode: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '委托单位', key: 'client', width: 200 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '委托编号', key: 'entrustCode', width: 120 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '进度', key: 'progress', width: 200, status: true },
        { title: '传真', key: 'fax', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '邮编', key: 'postcode' },
        { title: 'E-mail', key: 'email', width: 120 },
        { title: '委托日期', key: 'edate', width: 120 },
        { title: '费用合计', key: 'fee', width: 120 },
        { title: '合同号', key: 'contractCode', width: 120 },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '添加':
            this._editModal(false)
            break
          case '提交评审':
            this._submitToReview()
            break
          case '提交':
            this._submitToSkipReview()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },

    _submitToSkipReview() {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要提交 ' + ids.length + ' 条记录？',
          onOk: () => {
            this._subToSkipRe(ids)
          }
        })
      }
    },
    _subToSkipRe: async function(ids) {
      const result = await meterEntrust.submitSkipReview(ids)
      if (result) {
        this._resultChange('提交成功')
      }
    },
    _resultChange(msg) {
      this.$Message.success(msg)
      this._page()
    },
    _submitToReview() {
      this._submitByContractIds('委托评审')
    },
    _submitByContractIds(cont) {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要把这 ' + ids.length + ' 条记录提交到' + cont + '？',
          onOk: () => {
            this._submitOutReview(ids)
          }
        })
      }
    },

    _submitOutReview: async function(ids) {
      const result = await meterEntrust.submit(ids)
      if (result) {
        this.$Message.warning('提交成功！')
        await this._page()
      }
    },

    _sampleManage(data) {
      // 管理样品
      this.$refs.meterSampleManageModal._open(data)
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '编辑':
            this._editModal(true, data.id)
            break
          case '导出委托单':
            this._exportEntrust(data.id)
            break
          case '管理样品':
            this._sampleManage(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data)
            break
        }
      })
    },
    _record(data) {
      console.log(data)
      this.$refs.operationModal._open(data.id)
    },
    _exportEntrust(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定导出委托单？',
        onOk: () => {
          http.open('/meter/v1/entrust/export_out_entrust/?id=' + id)
        }
      })
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'selectIds':
          this.selectIds = data
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await meterEntrust.pageGoOutEntrust(this.formObj)
      if (result) {
        console.log(result)
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },
    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'contractId')
    },
    _getById: async function(id) {
      const result = await meterEntrust.getVOById(id)
      if (result) {
        this.$refs.editSubcontractorModal._openEdit(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterEntrust.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
